#ifndef _GLOBAL_H_
#define	_GLOBAL_H_

#include <stdlib.h>
#include "GenericTypeDefs.h"
#include "HardwareProfile.h"
#include "usb_config.h"
#include "USB/usb.h"
#include "USB/usb_host_bluetooth.h"
#include "user.h"
#include "timer.h"
#include "xprintf.h"
#include "btstack/debug.h"

#define PIN_CODE_DEFAULT	"0000"
#define BOARD_SBDBT         1
#define BOARD_SBXBT         0
#define	BOARD_SBRBT			0
#define	BOARD_SBGRBT		0

// Define the baud rate constants UART1
#define	USE_RFCOMM_BAUDRATE	0						//0:baud rate as fixed 1:baud rate as RFCOMM parameter from Master

#define RCB4DATA					 0		//RCB3=0, RCB4HV=1(RCB3HV=1?)
#if RCB4DATA
	// Define the baud rate constants UART1
	#define	UARTPARAM1			UARTPARAM_E81	//data=8bit parity=Even stopbit=1bit
	#define BAUDRATE1				115200		//UART1{[[g
#else
	// Define the baud rate constants UART1
	#define	UARTPARAM1			UARTPARAM_N81	//data=8bit parity=none stopbit=1bit
	#define BAUDRATE1				2400		//UART1{[[g
#endif
#define BRG_DIV1				     4
#define BRGH1					     1

#define	UART1_HW_FLOW			     0		//UART1n[hEFAt[ (0:Ȃ 1:)
#define	UART1_TX_POLARITY			 1		//MMɐ 0:ʏ 1:]
#define	UART1_RX_POLARITY			 1		//MMɐ 0:ʏ 1:]

#define	SEND_ON_DIFFERENT_DATA		35		//M^C~O 0:AM 1:Õf[^ƍƂ̂ݑM
#define	NEUTRAL_DATA_SUPPRESS		 1		//AM j[gʒũf[^ 0:AM  1:AM}

#define	UART1_MINIMUM_INTERVAL		 0		//d̎ɐꍇ 0:Ȃ 1ȏ:1d̍Œ᎞(ms)
#define	NEUTRAL_ADDITIONAL_PACKETS	 2		//j[gʒũf[^̂ݒǉőMpPbg 0:ǉȂ 1ȏ:ǉpPbg

#define	USE_STICK_FOR_DIGITAL		 1		//XeBbN͂ 0:AiOIɈ  1:fW^IɈ
#define	STICK_DEADZONE				10		//Sv}C܂łj[gƂĈ̂l
#define STICK_RESOLUTION			 0		//Ĺ͈F2-64,0:s,1:ӖȂ
#define STICK_MINIMUM_VALUE			 1		//XeBbN̍ŏlF0ɂꍇ̌듮
#define STICK_MAXIMUM_VALUE		   127		//XeBbN̍ől
#define STICK_NUTRAL_VALUE			64		//XeBbN̒l

// Define the baud rate constants UART2 (Debug)
#define BAUDRATE2       	115200
#define BRG_DIV2        	4
#define BRGH2           	1

// Define LED1 communication indicator on time(ms)
#define	LED1_ON_COUNT		10
#define	USE_RSSI			1						//0:blink rate as fixed 1:blink rate as RSSI (fast:lowRSSI slow:highRSSI)
#define	USE_WRITE_STORED_LINK_KEY	 1				//SPPڑ̃NL[ 0:PICFLASHɕۑ 1:BluetoothA_v^ɕۑ

#if BOARD_SBDBT
#define LOCAL_NAME			"SBDBT"
#define	ICSDEF				ICS_PGx1
#endif

#if BOARD_SBXBT
#define LOCAL_NAME			"SBXBT"
//#define	ICSDEF				ICS_PGx1
#define	ICSDEF				ICS_PGx3
#endif

#if BOARD_SBRBT
#define LOCAL_NAME			"SBRBT"
#define	ICSDEF				ICS_PGx1
#endif

#if BOARD_SBGRBT
#define LOCAL_NAME			"SBGRBT"
#define	ICSDEF				ICS_PGx1
#endif

#if	__DEBUG
//disable watchdog timer
#define	FWDTENDEF			FWDTEN_OFF
#define	RestartWatchdog()
#define STO_SERIAL			1   //0:STO as I/O  1:STO as serial output
#else
//enable watchdog timer
#define	FWDTENDEF			FWDTEN_ON
#define	RestartWatchdog()	ClrWdt()
#define STO_SERIAL			0   //0:STO as I/O  1:STO as serial output
#endif

#if BOARD_SBXBT
//
// for SBXBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB15=0)
#define	led1_on()			(LATBbits.LATB15=0)	//ON
#define	led1_off()			(LATBbits.LATB15=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB14=0)
#define	led2_on()			(LATBbits.LATB14=0)	//ON
#define	led2_off()			(LATBbits.LATB14=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)
// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

#if	STO_SERIAL
// Configure console OUT(U2TX) - put on pin 37 (RP20)
#define	sto_setup()			(RPOR10bits.RP20R = 5)
#define	sto_l()
#define	sto_h()
#else
// Configure RSSI(status) OUT - put on pin 37 (RC4)
#define	sto_setup()			(TRISCbits.TRISC4=0)
#define	sto_l()				(LATCbits.LATC4=0)
#define	sto_h()				(LATCbits.LATC4=1)
#endif

// Configure Association OUT - put on pin 20 (RA1)
#define	assoc_setup()		(TRISAbits.TRISA1=0)
#define	assoc_l()			(LATAbits.LATA1=0)
#define	assoc_h()			(LATAbits.LATA1=1)

// Configure ON OUT - put on pin 44 (RB8)
#define	on_setup()			{TRISBbits.TRISB8=0; LATBbits.LATB8=1;}

#define	pairen_setup()
#define	get_pairen()		(1)

#elif BOARD_SBDBT

//
//for SBDBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB14=0)
#define	led1_on()			(LATBbits.LATB14=0)	//ON
#define	led1_off()			(LATBbits.LATB14=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB15=0)
#define	led2_on()			(LATBbits.LATB15=0)	//ON
#define	led2_off()			(LATBbits.LATB15=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)
// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

#if	STO_SERIAL
// Configure console OUT(U2TX) - put on pin 1 (RP9)
#define	sto_setup()			(RPOR4bits.RP9R = 5)
#define	sto_l()
#define	sto_h()
#else
// Configure Status OUT - put on pin 1 (RB9)
#define	sto_setup()		(TRISBbits.TRISB9=0)
#define	sto_l()			(LATBbits.LATB9=0)
#define	sto_h()			(LATBbits.LATB9=1)
#endif

// no association out on this board
#define	assoc_setup()
#define	assoc_l()
#define	assoc_h()

// no on out on this board
#define	on_setup()

#define	pairen_setup()
#define	get_pairen()		(1)

#elif BOARD_SBRBT

//
//for SBRBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB14=0)
#define	led1_on()			(LATBbits.LATB14=0)	//ON
#define	led1_off()			(LATBbits.LATB14=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB15=0)
#define	led2_on()			(LATBbits.LATB15=0)	//ON
#define	led2_off()			(LATBbits.LATB15=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)


// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

// Configure Pairing enable in - put on pin 1 (RB9)
#define	sto_setup()
#define	sto_l()
#define	sto_h()

// no association out on this board
#define	assoc_setup()
#define	assoc_l()
#define	assoc_h()

// no on out on this board
#define	on_setup()

// Configure Pairing Enable Jumper - on pin 1 (RB9, CN21)
#define	pairen_setup()		{CNPU2bits.CN21PUE=1;}
#define	get_pairen()		(PORTBbits.RB9)

#elif BOARD_SBGRBT
//
//for SBRBT board
//
// Configure LED1 - put on pin 14 (RB14)
#define	led1_setup()		(TRISBbits.TRISB14=0)
#define	led1_on()			(LATBbits.LATB14=0)	//ON
#define	led1_off()			(LATBbits.LATB14=1)	//OFF

// Configure LED2 - put on pin 15 (RB15)
#define	led2_setup()		(TRISBbits.TRISB15=0)
#define	led2_on()			(LATBbits.LATB15=0)	//ON
#define	led2_off()			(LATBbits.LATB15=1)	//OFF

// Configure U1RX - put on pin 3 (RP23)
#define	u1rx_setup()		(RPINR18bits.U1RXR = 23)
// Configure U1TX - put on pin 2 (RP22)
#define u1tx_setup()		(RPOR11bits.RP22R = 3)


// Configure U1CTS - put on pin 4 (RP24)
#define	u1cts_setup()		(RPINR18bits.U1CTSR = 24)
// Configure U1RTS - put on pin 5 (RC9)
// U1RTS has software control
#define	u1rts_setup()		(TRISCbits.TRISC9=0)
#define	u1rts_on()			(LATCbits.LATC9=0)	//ON:rx ready
#define	u1rts_off()			(LATCbits.LATC9=1)	//OFF:rx not ready

// Configure Pairing enable in - put on pin 1 (RB9)
#define	sto_setup()
#define	sto_l()
#define	sto_h()

// no association out on this board
#define	assoc_setup()
#define	assoc_l()
#define	assoc_h()

// no on out on this board
#define	on_setup()

// Configure Pairing Enable Jumper - on pin 1 (RB9, CN21)
#define	pairen_setup()		{CNPU2bits.CN21PUE=1;}
#define	get_pairen()		(!PORTBbits.RB9)

#endif


#define Nop()    __builtin_nop()
#define ClrWdt() {__asm__ volatile ("clrwdt");}
#define Sleep()  {__asm__ volatile ("pwrsav #0");}
#define Idle()   {__asm__ volatile ("pwrsav #1");}
//#define	led1_on_mac()			{led1_on(); led1_on_count=timer_counter; led1_on_state=1;}
#define	led1_on_mac()

extern uint8_t	startup_state;
extern uint8_t	connection_status;
extern unsigned	led1_on_count;
extern uint8_t	led1_on_state;
extern unsigned	timer_counter;

extern void (*usb_tick_handler)(void);
void	event_bluetooth_rxEvent_done(WORD size);
void	event_bluetooth_rxAcl_done(WORD size);
int blemain(void);

extern WORD sixaxis_button_state;
extern BYTE sixaxis_lx;
extern BYTE sixaxis_ly;
extern BYTE sixaxis_rx;
extern BYTE sixaxis_ry;
extern char	lineBuffer[];

extern void (*usb_tick_handler)(void);
typedef unsigned clock_t;
clock_t clock(void);
void out_button_state(void);

/*
o͓dtH[}bg

RCB-3: 80
RCB-4: 0D 00 02 50 03 00: Checksum=0x62

: 80 00 01 40 40 40 40 01
: 80 00 02 40 40 40 40 02
: 80 00 04 40 40 40 40 04
: 80 00 08 40 40 40 40 08
: 80 00 10 40 40 40 40 10
~: 80 00 20 40 40 40 40 20
: 80 00 40 40 40 40 40 40
: 80 01 00 40 40 40 40 01
L1: 80 02 00 40 40 40 40 02
L2: 80 04 00 40 40 40 40 04
R1: 80 08 00 40 40 40 40 08
R2: 80 10 00 40 40 40 40 10

(Start): 80 00 03 40 40 40 40 03
(Select): 80 00 0C 40 40 40 40 0C

AiOE: 80 00 00 XX 40 40 40 XX
AiO㉺: 80 00 00 40 XX 40 40 XX
EAiOE: 80 00 00 40 40 XX 40 XX
EAiO㉺: 80 00 00 40 40 40 XX XX
*/

#define	OUT_DIGITAL_UP			0x0001
#define	OUT_DIGITAL_DOWN		0x0002
#define	OUT_DIGITAL_RIGHT		0x0004
#define	OUT_DIGITAL_LEFT		0x0008
#define	OUT_DIGITAL_TRIANGLE	0x0010
#define	OUT_DIGITAL_CROSS		0x0020
#define	OUT_DIGITAL_CIRCLE		0x0040
#define	OUT_DIGITAL_RECTANGLE	0x0100
#define	OUT_DIGITAL_L1			0x0200
#define	OUT_DIGITAL_L2			0x0400
#define	OUT_DIGITAL_R1			0x0800
#define	OUT_DIGITAL_R2			0x1000
#define	OUT_DIGITAL_START		0x0003
#define	OUT_DIGITAL_SELECT		0x000C
#define	OUT_DIGITAL_L3			0x0000
#define	OUT_DIGITAL_R3			0x0000
#define	OUT_DIGITAL_PS			0x0000

#endif
