#include <stdlib.h>
#define USE_AND_OR /* To enable AND_OR mask setting */
#include <ports.h>
#include <pps.h>
#include <timer.h>
#include <outcompare.h>
//#include "global.h"
#include "btstack/debug.h"
#include "btstack/btstack.h"
#include <btstack/hci_cmds.h>
#include <btstack/run_loop.h>

#include "btstack/hci.h"
#include "btstack/l2cap.h"
#include "btstack/btstack_memory.h"
#include "btstack/remote_device_db.h"
//#include "btstack/config.h"

unsigned	timer_counter=0;
unsigned	led1_on_count=0;
uint8_t		led1_on_state=0;
uint8_t		startup_state=0;

//static volatile clock_t			timer_counter=0;
//static unsigned					led1_on_count=0;
//static uint8_t					led1_on_state=0;
char							lineBuffer[50];

#if RCB4DATA
	#define			dataLen		13		//d
	#define			diffLen		5		//̍F13-8
#else
	#define			dataLen		8		//d
	#define			diffLen		0		//̍F8-8
#endif

#if	SEND_ON_DIFFERENTIAL || NEUTRAL_DATA_SUPPRESS
static char					lastsendbuf[dataLen];
#endif
#if	UART1_MINIMUM_INTERVAL
static clock_t					lastsendtime=0;
#endif

#define	BUTTON_STATE_INIT	0

hci_transport_t * hci_transport_picusb_instance();

#if defined(__PIC24FJ64GB004__)
	_CONFIG1(WDTPS_PS2048 & FWPSA_PR128 & WINDIS_OFF & FWDTENDEF & ICSDEF & GWRP_OFF & GCP_OFF & JTAGEN_OFF)
	_CONFIG2(POSCMOD_NONE & I2C1SEL_PRI & IOL1WAY_OFF & OSCIOFNC_ON & FCKSM_CSDCMD & FNOSC_FRCPLL & PLL96MHZ_ON & PLLDIV_DIV2 & IESO_OFF)
	_CONFIG3(WPFP_WPFP0 & SOSCSEL_IO & WUTSEL_LEG & WPDIS_WPDIS & WPCFG_WPCFGDIS & WPEND_WPENDMEM)
	_CONFIG4(DSWDTPS_DSWDTPS3 & DSWDTOSC_LPRC & RTCOSC_SOSC & DSBOREN_OFF & DSWDTEN_OFF)
#else

    #error Cannot define configuration bits.

#endif

BYTE        deviceAddress;  // Address of the device on the USB
bd_addr_t addr_global;

BOOL InitializeSystem ( void )
{
   #if defined(__PIC24FJ64GB004__)
	    {
	        unsigned int pll_startup_counter = 600;
	        CLKDIVbits.PLLEN = 1;
	        while(pll_startup_counter--);
	    }

		AD1PCFG = 0xffff;
	    CLKDIV = 0;    // Set PLL prescaler (1:1)
    #endif

	on_setup();
	led1_setup();
	led2_setup();
	u1rx_setup();
	u1tx_setup();
	u1cts_setup();
	u1rts_setup();
	sto_setup();
	assoc_setup();
	pairen_setup();

    // Init UART
    UART1Init(BAUDRATE1);
#if	STO_SERIAL
    UART2Init();
#endif

    return TRUE;
} // InitializeSystem

BOOL USB_ApplicationEventHandler ( BYTE address, USB_EVENT event, void *data, DWORD size )
{
    #ifdef USB_BLUETOOTH_SUPPORT_SERIAL_NUMBERS
        BYTE i;
    #endif

    // Handle specific events.
    switch (event)
    {
        case EVENT_BLUETOOTH_ATTACH:
            if (size == sizeof(BLUETOOTH_DEVICE_ID))
            {
                deviceAddress   = ((BLUETOOTH_DEVICE_ID *)data)->deviceAddress;
                log_info( "Bluetooth device attached - event, deviceAddress=%d\r\n",deviceAddress );
                #ifdef USB_BLUETOOTH_SUPPORT_SERIAL_NUMBERS
                    for (i=1; i<((BLUETOOTH_DEVICE_ID *)data)->serialNumberLength; i++)
                    {
                        xputc( ((BLUETOOTH_DEVICE_ID *)data)->serialNumber[i] );
                    }
	                xputs( "\r\n" );
                #endif
                return TRUE;
            }
            break;

        case EVENT_BLUETOOTH_DETACH:
            deviceAddress   = 0;
            log_info( "Bluetooth device detached - event\r\n" );
            return TRUE;

        case EVENT_BLUETOOTH_TX_CMD_DONE:           // The main state machine will poll the driver.
            return TRUE;

        case EVENT_BLUETOOTH_TX_ACL_DONE:           // The main state machine will poll the driver.
            return TRUE;

        case EVENT_BLUETOOTH_RX_EVENT_DONE:
			if(*(DWORD*)data){
				event_bluetooth_rxEvent_done((WORD)(*(DWORD*)data));
			}
            return TRUE;

        case EVENT_BLUETOOTH_RX_ACL_DONE:
			if(*(DWORD*)data){
				event_bluetooth_rxAcl_done((WORD)(*(DWORD*)data));
			}
            return TRUE;

        case EVENT_VBUS_REQUEST_POWER:
            // We'll let anything attach.
            return TRUE;

        case EVENT_VBUS_RELEASE_POWER:
            // We aren't keeping track of power.
            return TRUE;

        case EVENT_HUB_ATTACH:
            log_info( "\r\n***** USB Error - hubs are not supported *****\r\n" );
            return TRUE;
            break;

        case EVENT_UNSUPPORTED_DEVICE:
            log_info( "\r\n***** USB Error - device is not supported *****\r\n" );
            return TRUE;
            break;

        case EVENT_CANNOT_ENUMERATE:
            log_info( "\r\n***** USB Error - cannot enumerate device *****\r\n" );
            return TRUE;
            break;

        case EVENT_CLIENT_INIT_ERROR:
            log_info( "\r\n***** USB Error - client driver initialization error *****\r\n" );
            return TRUE;
            break;

        case EVENT_OUT_OF_MEMORY:
            log_info( "\r\n***** USB Error - out of heap memory *****\r\n" );
            return TRUE;
            break;

        case EVENT_UNSPECIFIED_ERROR:   // This should never be generated.
            log_info( "\r\n***** USB Error - unspecified *****\r\n" );
            return TRUE;
            break;

        case EVENT_SUSPEND:
        case EVENT_DETACH:
        case EVENT_RESUME:
        case EVENT_BUS_ERROR:
            return TRUE;
            break;

        default:
            break;
    }

    return FALSE;

} // USB_ApplicationEventHandler

#define	ANALOG_STATE_INIT		0x80

WORD sixaxis_button_state=BUTTON_STATE_INIT;
BYTE sixaxis_lx=ANALOG_STATE_INIT;
BYTE sixaxis_ly=ANALOG_STATE_INIT;
BYTE sixaxis_rx=ANALOG_STATE_INIT;
BYTE sixaxis_ry=ANALOG_STATE_INIT;

uint8_t getsum(void *buf,size_t size)
{
	const uint8_t	*p=(uint8_t*)buf;
	uint8_t			ret=0;

	for(;size;size--){
		ret+=*p++;
	}
	return ret;
}

uint8_t conv_analog(uint8_t ai)
{
	uint8_t ret;

	ai>>=1;
	if(ai>(STICK_NUTRAL_VALUE+STICK_DEADZONE)) {
	#if	USE_STICK_FOR_DIGITAL
		//XeBbNfW^IɈ
		ret=STICK_MAXIMUM_VALUE;
	#else
		//XeBbNAiOIɈ
		#if STICK_RESOLUTION
			ret=((ai+(STICK_RESOLUTION-1))\STTCK_RESOLUTION)*STICK_RESOLUTION-1;
		#endif
		if(ret>STICK_MAXIMUM_VALUE) ret=STICK_MAXIMUM_VALUE;
	#endif
	} else if(ai<(STICK_NUTRAL_VALUE-STICK_DEADZONE)) {
	#if	USE_STICK_FOR_DIGITAL
		//XeBbNfW^IɈ
		ret=STICK_MINIMUM_VALUE;
	#else
		//XeBbNAiOIɈ
		#if STICK_RESOLUTION
			ret=((ai\STICK_RESOLUTION)*STICK_RESOLUTION;
		#endif
		if(ret<STICK_MINIMUM_VALUE) ret=STICK_MINIMUM_VALUE;
	#endif
	} else {
		ret=STICK_NUTRAL_VALUE;	//j[gƂĈ
	}

	return ret;
}

//j[g̃f[^
#if RCB4DATA
	const uint8_t neutral_packet[]={0x0D,0x00,0x02,0x50,0x03,0x00,0x00,0x00,0x40,0x40,0x40,0x40,};	
#else
	const uint8_t neutral_packet[]={0x80,0x00,0x00,0x40,0x40,0x40,0x40,};
#endif

clock_t clock(void)
{
	return timer_counter;
}

void UART1PutBuf(char *buf,size_t size)
{
#if	UART1_MINIMUM_INTERVAL
	for(;(clock()-lastsendtime)<UART1_MINIMUM_INTERVAL;){
	}
	lastsendtime=clock();
#endif

	for(;size;size--){
		UART1PutChar(*buf++);
	}
	return;
}

void out_button_state(void)
{
	//d@Œl
#if RCB4DATA
	lineBuffer[0]=0x0D;
	lineBuffer[1]=0x00;
	lineBuffer[2]=0x02;
	lineBuffer[3]=0x50;
	lineBuffer[4]=0x03;
	lineBuffer[5]=0x00;
#else
	lineBuffer[0]=0x80; //1oCg:0x80Œ
#endif
	//d̍쐬
	lineBuffer[1+diffLen]=(sixaxis_button_state>>8)&0xff;	//2oCg:{^ԃfW^1
	lineBuffer[2+diffLen]=(sixaxis_button_state>>0)&0xff;	//3oCg:{^ԃfW^2
#if RCB4DATA
	//yxyx
	lineBuffer[3+diffLen]=conv_analog(0xFF-sixaxis_ly);		//4oCg:XeBbNy(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[4+diffLen]=conv_analog(sixaxis_lx);			//5oCg:XeBbNx(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[5+diffLen]=conv_analog(0xFF-sixaxis_ry);		//6oCg:EXeBbNy(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[6+diffLen]=conv_analog(sixaxis_rx);			//7oCg:EXeBbNx(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[7+diffLen]=(getsum(lineBuffer,dataLen-1)&0xFF);	//8oCg:`FbNT
#else
	//xyxy
	lineBuffer[3+diffLen]=conv_analog(sixaxis_lx);			//4oCg:XeBbNX(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[4+diffLen]=conv_analog(sixaxis_ly);			//5oCg:XeBbNY(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[5+diffLen]=conv_analog(sixaxis_rx);			//6oCg:EXeBbNX(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[6+diffLen]=conv_analog(sixaxis_ry);			//7oCg:EXeBbNY(0x00-0x7f) AiÔ悤ŃfW^
	lineBuffer[7+diffLen]=(getsum(lineBuffer,dataLen-1)&0x7f);	//8oCg:`FbNT7rbg
#endif

#if	SEND_ON_DIFFERENT_DATA
	//Oƍ̂ݑM
	if(memcmp(lastsendbuf,lineBuffer,dataLen)){			//O񑗐Mf[^ƍꍇ̂ݑM
		led1_on_mac();									//ԐFLED_
		log_info("out %02x %02x %02x %02x %02x %02x %02x %02x\n",
			((uint8_t*)lineBuffer)[0+diffLen],
			((uint8_t*)lineBuffer)[1+diffLen],
			((uint8_t*)lineBuffer)[2+diffLen],
			((uint8_t*)lineBuffer)[3+diffLen],
			((uint8_t*)lineBuffer)[4+diffLen],
			((uint8_t*)lineBuffer)[5+diffLen],
			((uint8_t*)lineBuffer)[6+diffLen],
			((uint8_t*)lineBuffer)[7+diffLen]
		);
		UART1PutBuf(lineBuffer,dataLen);						//f[^M

#if	NEUTRAL_ADDITIONAL_PACKETS
		if(!memcmp(neutral_packet,lineBuffer,sizeof(neutral_packet))){	//̃f[^̓j[g
			unsigned nc;
			for(nc=0;nc<NEUTRAL_ADDITIONAL_PACKETS;nc++){
				UART1PutBuf(lineBuffer,dataLen);				//j[g̃f[^̏ꍇ͒ǉő
			}
		}
#endif
		memcpy(lastsendbuf,lineBuffer,dataLen);				//Mf[^rpɕۑ
	}
#else
	//AM
#if	UART1_MINIMUM_INTERVAL
	if((clock()-lastsendtime)>=UART1_MINIMUM_INTERVAL){
#endif
#if	NEUTRAL_DATA_SUPPRESS
		if(memcmp(neutral_packet,lineBuffer,sizeof(neutral_packet)) || memcmp(lastsendbuf,lineBuffer,dataLen)){	//̃f[^̓j[g
#endif
			if(UART1GetBufferSpace()>=dataLen){
				led1_on_mac();									//ԐFLED_
				log_info("out %02x %02x %02x %02x %02x %02x %02x %02x\n",
					((uint8_t*)lineBuffer)[0+diffLen],
					((uint8_t*)lineBuffer)[1+diffLen],
					((uint8_t*)lineBuffer)[2+diffLen],
					((uint8_t*)lineBuffer)[3+diffLen],
					((uint8_t*)lineBuffer)[4+diffLen],
					((uint8_t*)lineBuffer)[5+diffLen],
					((uint8_t*)lineBuffer)[6+diffLen],
					((uint8_t*)lineBuffer)[7+diffLen]
				);
				UART1PutBuf(lineBuffer,dataLen);						//f[^M
		
#if	NEUTRAL_ADDITIONAL_PACKETS
				if(!memcmp(neutral_packet,lineBuffer,sizeof(neutral_packet))){	//̃f[^̓j[g
					unsigned nc;
					for(nc=0;nc<NEUTRAL_ADDITIONAL_PACKETS;nc++){
						UART1PutBuf(lineBuffer,dataLen);				//j[g̃f[^̏ꍇ͒ǉő
					}
				}
#endif
#if	NEUTRAL_DATA_SUPPRESS
				memcpy(lastsendbuf,lineBuffer,dataLen);				//Mf[^rpɕۑ
#endif
			}
#if	NEUTRAL_DATA_SUPPRESS
		}
#endif
#if	UART1_MINIMUM_INTERVAL
	}
#endif
#endif

	return;
}

int main ( void )
{
	RestartWatchdog();

    // Initialize the processor and peripherals.
    if ( InitializeSystem() != TRUE )
    {
        log_info( "\r\n\r\nCould not initialize " LOCAL_NAME " - system.  Halting.\r\n\r\n" );
        while (1);
    }
	xdev_out(UART2PutChar);
    if ( USBHostInit(0) == TRUE )
    {
        log_info( "\r\n\r\n***** " LOCAL_NAME " Initialized *****\r\n\r\n" );
    }
    else
    {
        log_info( "\r\n\r\nCould not initialize " LOCAL_NAME " - USB.  Halting.\r\n\r\n" );
        while (1);
    }

    // Main Processing Loop
    while(!deviceAddress)
    {
        // This demo does not check for overcurrent conditions.  See the
        // USB Host - Data Logger for an example of overcurrent detection
        // with the PIC24F and the USB PICtail Plus.

        // Maintain USB Host State
        USBHostTasks();

        //if (CheckForNewAttach()){
		//	break;
        //}
    }

	DelayMs(1000);

	blemain();

    return 0;

} // main


void hal_tick_init(void)
{
	usb_tick_handler=NULL;
}

void hal_tick_set_handler(void (*tick_handler)(void))
{
	usb_tick_handler=tick_handler;
}

void hal_tick_event(void)
{
	timer_counter++;

	RestartWatchdog();

	if(!startup_state && timer_counter>5000){
		Reset();
	}

	if(connection_status){
        if(timer_counter&0x100){
            led2_off();
        }else{
            led2_on();
        }
	}else{
		led2_on();
	}

#if	0
	if(led1_on_state && (timer_counter-led1_on_count)>LED1_ON_COUNT){
		led1_off();
		led1_on_state=0;
	}
#endif

	// call tick handler
	if(usb_tick_handler){
		usb_tick_handler();
	}
}

/*************************************************************************
 * EOF main.c
 */

